import { defineComponent, $prefix, $props, setup } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/tabbar-item/vue';
import Badge from '@opentinyvue/vue-badge';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var __vue2_script = defineComponent({
  name: $prefix + "TabbarItem",
  componentName: "TabbarItem",
  props: _extends({}, $props, {
    dot: Boolean,
    icon: Object,
    name: [Number, String],
    badge: [Number, String],
    text: String,
    customIcon: {
      type: Boolean,
      default: false
    }
  }),
  components: {
    TinyBadge: Badge
  },
  setup: function setup$1(props, context) {
    return setup({
      props,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.state.showVm ? _c("div", {
    class: _vm.m("flex flex-1 flex-col items-center justify-center cursor-pointer mx-0.5 [&:first-of-type]:ml-1 [&:last-of-type]:mr-1", _vm.state.customIcon ? "my-1.5" : "my-1"),
    style: {
      color: _vm.state.renderColor
    },
    attrs: {
      "data-tag": "tiny-tabbar-item"
    },
    on: {
      "click": _vm.onClick
    }
  }, [_c("div", {
    class: ["relative pointer-events-none", _vm.state.customIcon ? "w-11 h-11 [&_svg]:w-11 [&_svg]:h-11" : "w-6 h-6 [&_svg]:w-6 [&_svg]:h-6 my-1"],
    attrs: {
      "data-tag": "tiny-tabbar-item-icon"
    }
  }, [_vm._t("icon", function() {
    return [_vm.badge ? _c("tiny-badge", {
      attrs: {
        "type": "icon",
        "value": _vm.badge
      }
    }, [_c(_vm.icon, {
      tag: "component",
      class: {
        "fill-color-brand": _vm.state.renderActive || _vm.state.customIcon
      },
      style: {
        fill: _vm.state.renderColor
      }
    })], 1) : _vm.dot ? _c("tiny-badge", {
      attrs: {
        "type": "icon",
        "is-dot": _vm.dot
      }
    }, [_c(_vm.icon, {
      tag: "component",
      class: {
        "fill-color-brand": _vm.state.renderActive || _vm.state.customIcon
      },
      style: {
        fill: _vm.state.renderColor
      }
    })], 1) : _c(_vm.icon, {
      tag: "component",
      class: {
        "fill-color-brand": _vm.state.renderActive || _vm.state.customIcon
      },
      style: {
        fill: _vm.state.renderColor
      }
    })];
  }, {
    "active": _vm.state.renderActive
  })], 2), !_vm.state.customIcon ? _c("div", {
    class: ["pointer-events-none overflow-hidden whitespace-nowrap text-ellipsis text-xs text-center leading-3", {
      "text-color-brand": _vm.state.renderActive
    }],
    style: {
      color: _vm.state.renderColor,
      width: _vm.state.itemWidth
    },
    attrs: {
      "data-tag": "tiny-tabbar-item-title"
    }
  }, [_vm._t("default", function() {
    return [_vm._v(_vm._s(_vm.text || _vm.name))];
  })], 2) : _vm._e()]) : _vm._e();
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
